#include "Szene.hpp"
#include "main.h"
std::vector<Renderable> Szene::szene;
Renderable Szene::lightSource;
std::vector<Renderable>Szene::Skybox;
std::vector<glm::vec3> Szene::testcube_vert;
std::vector<glm::vec3> Szene::testcube_norm;
std::vector<glm::vec3> Szene::testcube_color;

void Szene::init()
{
	initTestCube();

	Renderable lightSrc(Szene::testcube_vert,Szene::testcube_color);
	lightSrc.setName("LICHT");
	lightSrc.setColor(glm::vec3(1,1,1));
	lightSrc.setPosition(glm::vec3(5.0f, 20.0f, 0.0f));
	lightSrc.addNormals(Szene::testcube_norm);
	lightSrc.bufferData();
	lightSrc.setVisible(true);
	Szene::lightSource=lightSrc;
	Szene::szene.push_back(lightSource);/**/

	/*GLuint tetris_l_tex = loadBMP_custom((project::textures+SEP+"L_texture.bmp").data());
	Renderable tetris_l(project::models+SEP+("L.3ds"));
    tetris_l.setName("L");
    tetris_l.setPosition(glm::vec3(0,0,-5));
	tetris_l.setRotation(glm::vec3(0,0,90));
    tetris_l.bufferData();
	tetris_l.setTextureId(tetris_l_tex);
    Szene::szene.insert(Szene::szene.end(), tetris_l);/**/

	
	//Renderable test(project::models+SEP+"fancyT.3ds");
	Renderable test(project::models+SEP+"sphere.3ds");
	//Renderable test(Szene::testcube_vert,Szene::testcube_color);
    test.setName("testcube");
	test.setScale(glm::vec3(2.5));
    test.setPosition(glm::vec3(-12,3,0));
	test.setColor(glm::vec3(1,0,0));
	test.setRotation(glm::vec3(270,0,0));
    test.bufferData();
	test.setReflection(true);
	//test.setTextureId(barrel_tex);
    Szene::szene.insert(Szene::szene.end(), test);

	GLuint barrel_tex = loadBMP_custom((project::textures+SEP+"barrel.bmp").data());
	Renderable barrel(project::models+SEP+("barrel.3ds"));
    barrel.setName("Barrel");
    barrel.setPosition(glm::vec3(-25,-4,16));
	barrel.setRotation(glm::vec3(270,0,0));
	barrel.setScale(glm::vec3(0.5, 0.5, 0.5));
    barrel.bufferData();
	barrel.setTextureId(barrel_tex);
    Szene::szene.insert(Szene::szene.end(), barrel);/**/

	Renderable barrel2(project::models+SEP+("barrel.3ds"));
    barrel2.setName("Barrel2");
    barrel2.setPosition(glm::vec3(25,-4,16));
	barrel2.setRotation(glm::vec3(270,0,0));
	barrel2.setScale(glm::vec3(0.5, 0.5, 0.5));
    barrel2.bufferData();
	barrel2.setTextureId(barrel_tex);
    Szene::szene.insert(Szene::szene.end(), barrel2);/**/

	Renderable barrel3(project::models+SEP+("barrel.3ds"));
    barrel3.setName("Barrel3");
    barrel3.setPosition(glm::vec3(-25,-4,-16));
	barrel3.setRotation(glm::vec3(270,0,0));
	barrel3.setScale(glm::vec3(0.5, 0.5, 0.5));
    barrel3.bufferData();
	barrel3.setTextureId(barrel_tex);
    Szene::szene.insert(Szene::szene.end(), barrel3);/**/

	Renderable barrel4(project::models+SEP+("barrel.3ds"));
    barrel4.setName("Barrel4");
    barrel4.setPosition(glm::vec3(25,-4,-16));
	barrel4.setRotation(glm::vec3(270,0,0));
	barrel4.setScale(glm::vec3(0.5, 0.5, 0.5));
    barrel4.bufferData();
	barrel4.setTextureId(barrel_tex);
    Szene::szene.insert(Szene::szene.end(), barrel4);/**/


	GLuint tetris_j_tex = loadBMP_custom((project::textures+SEP+"J_texture.bmp").data());
	Renderable tetris_j(project::models+SEP+("J.3ds"));
    tetris_j.setName("J");
    tetris_j.setPosition(glm::vec3(0,-1.1,-4.4));
	tetris_j.setRotation(glm::vec3(270,0,90));
    tetris_j.bufferData();
	tetris_j.setTextureId(tetris_j_tex);
    Szene::szene.insert(Szene::szene.end(), tetris_j);/**/

	GLuint tetris_j2_tex = loadBMP_custom((project::textures+SEP+"J_texture.bmp").data());
	Renderable tetris_j2(project::models+SEP+("J.3ds"));
    tetris_j2.setName("J2");
    tetris_j2.setPosition(glm::vec3(0,1.1,4.4));
	tetris_j2.setRotation(glm::vec3(90,0,90));
    tetris_j2.bufferData();
	tetris_j2.setTextureId(tetris_j2_tex);
    Szene::szene.insert(Szene::szene.end(), tetris_j2);/**/

	GLuint tetris_j3_tex = loadBMP_custom((project::textures+SEP+"J_texture.bmp").data());
	Renderable tetris_j3(project::models+SEP+("J.3ds"));
    tetris_j3.setName("J3");
    tetris_j3.setPosition(glm::vec3(0,4.4,1.1));
	tetris_j3.setRotation(glm::vec3(90,0,90));
    tetris_j3.bufferData();
	tetris_j3.setTextureId(tetris_j3_tex);
    Szene::szene.insert(Szene::szene.end(), tetris_j3);/**/

	GLuint tetris_o_tex = loadBMP_custom((project::textures+SEP+"O_texture.bmp").data());
	Renderable tetris_o(project::models+SEP+("O.3ds"));
    tetris_o.setName("O");
    tetris_o.setPosition(glm::vec3(0,-1.1,2.2));
	tetris_o.setRotation(glm::vec3(0,0,90));
    tetris_o.bufferData();
	tetris_o.setTextureId(tetris_o_tex);
    Szene::szene.insert(Szene::szene.end(), tetris_o);/**/

	/*GLuint tetris_s_tex = loadBMP_custom((project::textures+SEP+"S_texture.bmp").data());
	Renderable tetris_s(project::models+SEP+("S.3ds"));
    tetris_s.setName("S");
    tetris_s.setPosition(glm::vec3(0,5,0));
	tetris_s.setRotation(glm::vec3(0,0,90));
    tetris_s.bufferData();
	tetris_s.setTextureId(tetris_s_tex);
    Szene::szene.insert(Szene::szene.end(), tetris_s);/**/

	GLuint tetris_t_tex = loadBMP_custom((project::textures+SEP+"T_texture.bmp").data());
	Renderable tetris_t(project::models+SEP+("T.3ds"));
    tetris_t.setName("T");
    tetris_t.setPosition(glm::vec3(0,0,0));
	tetris_t.setRotation(glm::vec3(90,0,90));
    tetris_t.bufferData();
	tetris_t.setTextureId(tetris_t_tex);
	Szene::szene.insert(Szene::szene.end(), tetris_t);/**/

	GLuint tetris_t2_tex = loadBMP_custom((project::textures+SEP+"T_texture.bmp").data());
	Renderable tetris_t2(project::models+SEP+("T.3ds"));
    tetris_t2.setName("T2");
    tetris_t2.setPosition(glm::vec3(0,1.1,-2.2));
	tetris_t2.setRotation(glm::vec3(0,0,90));
    tetris_t2.bufferData();
	tetris_t2.setTextureId(tetris_t2_tex);
	Szene::szene.insert(Szene::szene.end(), tetris_t2);/**/

	GLuint tetris_t3_tex = loadBMP_custom((project::textures+SEP+"T_texture.bmp").data());
	Renderable tetris_t3(project::models+SEP+("T.3ds"));
    tetris_t3.setName("T3");
    tetris_t3.setPosition(glm::vec3(0,0,1.1));
	tetris_t3.setRotation(glm::vec3(270,0,90));
    tetris_t3.bufferData();
	tetris_t3.setTextureId(tetris_t3_tex);
	Szene::szene.insert(Szene::szene.end(), tetris_t3);/**/

	GLuint tetris_z_tex = loadBMP_custom((project::textures+SEP+"Z_texture.bmp").data());
	Renderable tetris_z(project::models+SEP+("Z.3ds"));
    tetris_z.setName("Z");
    tetris_z.setPosition(glm::vec3(0,0,-3.3));
	tetris_z.setRotation(glm::vec3(0,0,90));
    tetris_z.bufferData();
	tetris_z.setTextureId(tetris_z_tex);
    Szene::szene.insert(Szene::szene.end(), tetris_z);/**/

	GLuint tetris_z2_tex = loadBMP_custom((project::textures+SEP+"Z_texture.bmp").data());
	Renderable tetris_z2(project::models+SEP+("Z.3ds"));
    tetris_z2.setName("Z2");
    tetris_z2.setPosition(glm::vec3(0,3.3,-1.1));
	tetris_z2.setRotation(glm::vec3(0,0,90));
    tetris_z2.bufferData();
	tetris_z2.setTextureId(tetris_z2_tex);
    Szene::szene.insert(Szene::szene.end(), tetris_z2);/**/

	GLuint streetlamp_tex = loadBMP_custom((project::textures+SEP+"streetlamp_texture.bmp").data());
	Renderable streetlamp(project::models+SEP+("streetlamp.3ds"));
    streetlamp.setName("Streetlamp");
    streetlamp.setPosition(glm::vec3(0,-2,-15));
	streetlamp.setRotation(glm::vec3(270,0,0));
	streetlamp.setScale(glm::vec3(0.8,0.8,0.8));
    streetlamp.bufferData();
	streetlamp.setTextureId(streetlamp_tex);
    Szene::szene.insert(Szene::szene.end(), streetlamp);/**/

	GLuint plane_tex = loadBMP_custom((project::textures+SEP+"ground17.bmp").data());
	Renderable plane(project::models+SEP+("plane.3ds"));
	plane.setName("Plane");
	plane.setTextureId(plane_tex);
    plane.setTessellation(false);
	plane.setVisible(true);
	plane.setTessellationParameterFixed(8.0f,25.0f,10.0,10.0,10.0);
    plane.setPosition(glm::vec3(-5,-1.75,5.0));
	plane.setScale(glm::vec3(10,1,10));
	plane.setRotation(glm::vec3(-90,0,0));
    plane.bufferData();
    Szene::szene.push_back(plane);/**/

	Renderable plane2(project::models+SEP+("plane.3ds"));
	plane2.setName("Plane2");
	plane2.setTextureId(plane_tex);
    plane2.setTessellation(false);
	plane2.setVisible(true);
	plane2.setTessellationParameterFixed(8.0f,25.0f,10.0,10.0,10.0);
    plane2.setPosition(glm::vec3(-5,-1.75,-5.0));
	plane2.setScale(glm::vec3(10,1,10));
	plane2.setRotation(glm::vec3(-90,0,0));
    plane2.bufferData();
    Szene::szene.push_back(plane2);/**/

	Renderable plane3(project::models+SEP+("plane.3ds"));
	plane3.setName("Plane3");
	plane3.setTextureId(plane_tex);
    plane3.setTessellation(false);
	plane3.setVisible(true);
	plane3.setTessellationParameterFixed(8.0f,25.0f,10.0,10.0,10.0);
    plane3.setPosition(glm::vec3(5,-1.75,5.0));
	plane3.setScale(glm::vec3(10,1,10));
	plane3.setRotation(glm::vec3(-90,0,0));
    plane3.bufferData();
    Szene::szene.push_back(plane3);/**/

	Renderable plane4(project::models+SEP+("plane.3ds"));
	plane4.setName("Plane4");
	plane4.setTextureId(plane_tex);
    plane4.setTessellation(false);
	plane4.setVisible(true);
	plane4.setTessellationParameterFixed(8.0f,25.0f,10.0,10.0,10.0);
    plane4.setPosition(glm::vec3(5,-1.75,-5.0));
	plane4.setScale(glm::vec3(10,1,10));
	plane4.setRotation(glm::vec3(-90,0,0));
    plane4.bufferData();
    Szene::szene.push_back(plane4);/**/

	

	GLuint water_tex = loadBMP_custom((project::textures+SEP+"water.bmp").data());
	Renderable water(project::models+SEP+("plane.3ds"));
	water.setName("Water");
	water.setTextureId(water_tex);
    water.setTessellation(true);
	water.setVisible(false);
	water.setTessellationParameterFixed(8.0f,25.0f,10.0,10.0,10.0);
    water.setPosition(glm::vec3(0,-2,0));
	water.setScale(glm::vec3(10,1,10));
	water.setRotation(glm::vec3(-90,0,0));
    water.bufferData();
    Szene::szene.push_back(water);/**/


	//GLuint sky_tex = loadBMP_custom((project::textures+SEP+"skybox.bmp").data());
	GLuint *sky_tex = splitSkybox((project::textures+SEP+"skybox.bmp").data());
	int j = 0;
	for(int i =0; i<6; i++)
	{

		if(i==3)
			continue;
		j++;
		Renderable s = setupSky(i);
		s.setTextureId(sky_tex[i]);
		//Skybox[j]=s;
		Szene::Skybox.push_back(s);
	}
	delete [] sky_tex;
	
    
	//TESTCUBE:
    /*Renderable testcube(Szene::testcube_vert,Szene::testcube_color);
    testcube.setPosition(glm::vec3(-3,1,-1));
    testcube.setName("testcube");
    testcube.addNormals(Szene::testcube_norm);
    testcube.bufferData();
    Szene::szene.push_back(testcube); /**/	
}
//CUBEMAP_indizes
Renderable setupSky(int index)
{
	glm::vec3 rot[6] =
	{
		glm::vec3(0,90,0),
		glm::vec3(0,-90,0),
		glm::vec3(-90,0,0),
		glm::vec3(90,0,0),
		glm::vec3(0,180,0),
		glm::vec3(0,0,0)

	};
	float p = 100;
	glm::vec3 pos[6] =
	{
		glm::vec3(p,0,0),
		glm::vec3(-p,0,0),
		glm::vec3(0,p,0),
		glm::vec3(0,-p,0),
		glm::vec3(0,0,-p),
		glm::vec3(0,0,p)

	};
	float s=20.1;
	glm::vec3 scale[6] =
	{
		glm::vec3(1,s,s),
		glm::vec3(1,s,s),
		glm::vec3(s,1,s),
		glm::vec3(s,1,s),
		glm::vec3(s,s,1),
		glm::vec3(s,s,1)

	};
	Renderable sky(project::models+SEP+("plane.3ds"));
	char *name="sky0";
	char numstr[2]; // enough to hold all numbers up to 64-bits
	sprintf(numstr, "%d", index);
	sky.setName((std::string("sky")+numstr).data());
    sky.setTessellation(false);
	sky.setVisible(true);
	sky.setDepthTest(false);
    sky.setPosition(pos[index]);
	sky.setScale(scale[index]);
	sky.setRotation(rot[index]);
    sky.bufferData();
	return sky;
}
void Szene::initTestCube()
{
	//front
	Szene::testcube_vert.push_back(glm::vec3(-1,-1,1));
	Szene::testcube_vert.push_back(glm::vec3(-1,1,1));
	Szene::testcube_vert.push_back(glm::vec3(1,-1,1));
	Szene::testcube_vert.push_back(glm::vec3(1,-1,1));
    Szene::testcube_vert.push_back(glm::vec3(-1,1,1));
	Szene::testcube_vert.push_back(glm::vec3(1,1,1));

	/*Szene::testcube_norm.push_back(glm::vec3(-1,-1,1));
	Szene::testcube_norm.push_back(glm::vec3(-1,1,1));
	Szene::testcube_norm.push_back(glm::vec3(1,-1,1));
	Szene::testcube_norm.push_back(glm::vec3(1,-1,1));
    Szene::testcube_norm.push_back(glm::vec3(-1,1,1));
	Szene::testcube_norm.push_back(glm::vec3(1,1,1));*/

	glm::vec3 facenorm = glm::vec3(0,0,1);
	Szene::testcube_norm.push_back(facenorm);
	Szene::testcube_norm.push_back(facenorm);
	Szene::testcube_norm.push_back(facenorm);
	Szene::testcube_norm.push_back(facenorm);
	Szene::testcube_norm.push_back(facenorm);
	Szene::testcube_norm.push_back(facenorm);

	Szene::testcube_color.push_back(glm::vec3(1,0,0));
	Szene::testcube_color.push_back(glm::vec3(1,0,0));
	Szene::testcube_color.push_back(glm::vec3(1,0,0));
	Szene::testcube_color.push_back(glm::vec3(1,0,0));
	Szene::testcube_color.push_back(glm::vec3(1,0,0));
	Szene::testcube_color.push_back(glm::vec3(1,0,0));

	//back
	Szene::testcube_vert.push_back(glm::vec3(-1,-1,-1));
	Szene::testcube_vert.push_back(glm::vec3(-1,1,-1));
	Szene::testcube_vert.push_back(glm::vec3(1,-1,-1));
	Szene::testcube_vert.push_back(glm::vec3(1,-1,-1));
    Szene::testcube_vert.push_back(glm::vec3(-1,1,-1));
	Szene::testcube_vert.push_back(glm::vec3(1,1,-1));

	/*Szene::testcube_norm.push_back(glm::vec3(-1,-1,-1));
	Szene::testcube_norm.push_back(glm::vec3(-1,1,-1));
	Szene::testcube_norm.push_back(glm::vec3(1,-1,-1));
	Szene::testcube_norm.push_back(glm::vec3(1,-1,-1));
    Szene::testcube_norm.push_back(glm::vec3(-1,1,-1));
	Szene::testcube_norm.push_back(glm::vec3(1,1,-1));*/
	facenorm = glm::vec3(0,0,-1);
	Szene::testcube_norm.push_back(facenorm);
	Szene::testcube_norm.push_back(facenorm);
	Szene::testcube_norm.push_back(facenorm);
	Szene::testcube_norm.push_back(facenorm);
	Szene::testcube_norm.push_back(facenorm);
	Szene::testcube_norm.push_back(facenorm);


	Szene::testcube_color.push_back(glm::vec3(0,1,0));
	Szene::testcube_color.push_back(glm::vec3(0,1,0));
	Szene::testcube_color.push_back(glm::vec3(0,1,0));
	Szene::testcube_color.push_back(glm::vec3(0,1,0));
	Szene::testcube_color.push_back(glm::vec3(0,1,0));
	Szene::testcube_color.push_back(glm::vec3(0,1,0));

	//left
	Szene::testcube_vert.push_back(glm::vec3(-1,-1,1));
	Szene::testcube_vert.push_back(glm::vec3(-1,1,1));
	Szene::testcube_vert.push_back(glm::vec3(-1,-1,-1));
	Szene::testcube_vert.push_back(glm::vec3(-1,-1,-1));
    Szene::testcube_vert.push_back(glm::vec3(-1,1,-1));
	Szene::testcube_vert.push_back(glm::vec3(-1,1,1));

/*	Szene::testcube_norm.push_back(glm::vec3(-1,-1,1));
	Szene::testcube_norm.push_back(glm::vec3(-1,1,1));
	Szene::testcube_norm.push_back(glm::vec3(-1,-1,-1));
	Szene::testcube_norm.push_back(glm::vec3(-1,-1,-1));
    Szene::testcube_norm.push_back(glm::vec3(-1,1,-1));
	Szene::testcube_norm.push_back(glm::vec3(-1,1,1));*/
	facenorm = glm::vec3(-1,0,0);
	Szene::testcube_norm.push_back(facenorm);
	Szene::testcube_norm.push_back(facenorm);
	Szene::testcube_norm.push_back(facenorm);
	Szene::testcube_norm.push_back(facenorm);
	Szene::testcube_norm.push_back(facenorm);
	Szene::testcube_norm.push_back(facenorm);

	Szene::testcube_color.push_back(glm::vec3(0,0,1));
	Szene::testcube_color.push_back(glm::vec3(0,0,1));
	Szene::testcube_color.push_back(glm::vec3(0,0,1));
	Szene::testcube_color.push_back(glm::vec3(0,0,1));
	Szene::testcube_color.push_back(glm::vec3(0,0,1));
	Szene::testcube_color.push_back(glm::vec3(0,0,1));

	//right
	Szene::testcube_vert.push_back(glm::vec3(1,-1,1));
	Szene::testcube_vert.push_back(glm::vec3(1,1,1));
	Szene::testcube_vert.push_back(glm::vec3(1,-1,-1));
	Szene::testcube_vert.push_back(glm::vec3(1,-1,-1));
    Szene::testcube_vert.push_back(glm::vec3(1,1,-1));
	Szene::testcube_vert.push_back(glm::vec3(1,1,1));

	/*Szene::testcube_norm.push_back(glm::vec3(1,-1,1));
	Szene::testcube_norm.push_back(glm::vec3(1,1,1));
	Szene::testcube_norm.push_back(glm::vec3(1,-1,-1));
	Szene::testcube_norm.push_back(glm::vec3(1,-1,-1));
    Szene::testcube_norm.push_back(glm::vec3(1,1,-1));
	Szene::testcube_norm.push_back(glm::vec3(1,1,1));*/
	facenorm = glm::vec3(1,0,0);
	Szene::testcube_norm.push_back(facenorm);
	Szene::testcube_norm.push_back(facenorm);
	Szene::testcube_norm.push_back(facenorm);
	Szene::testcube_norm.push_back(facenorm);
	Szene::testcube_norm.push_back(facenorm);
	Szene::testcube_norm.push_back(facenorm);

	Szene::testcube_color.push_back(glm::vec3(1,0,1));
	Szene::testcube_color.push_back(glm::vec3(1,0,1));
	Szene::testcube_color.push_back(glm::vec3(1,0,1));
	Szene::testcube_color.push_back(glm::vec3(1,0,1));
	Szene::testcube_color.push_back(glm::vec3(1,0,1));
	Szene::testcube_color.push_back(glm::vec3(1,0,1));
	
	//top
	Szene::testcube_vert.push_back(glm::vec3(-1,1,1));
	Szene::testcube_vert.push_back(glm::vec3(-1,1,-1));
	Szene::testcube_vert.push_back(glm::vec3(1,1,1));
	Szene::testcube_vert.push_back(glm::vec3(1,1,1));
    Szene::testcube_vert.push_back(glm::vec3(1,1,-1));
	Szene::testcube_vert.push_back(glm::vec3(-1,1,-1));

	/*Szene::testcube_norm.push_back(glm::vec3(-1,1,1));
	Szene::testcube_norm.push_back(glm::vec3(-1,1,-1));
	Szene::testcube_norm.push_back(glm::vec3(1,1,1));
	Szene::testcube_norm.push_back(glm::vec3(1,1,1));
    Szene::testcube_norm.push_back(glm::vec3(1,1,-1));
	Szene::testcube_norm.push_back(glm::vec3(-1,1,-1));*/
	facenorm = glm::vec3(0,1,0);
	Szene::testcube_norm.push_back(facenorm);
	Szene::testcube_norm.push_back(facenorm);
	Szene::testcube_norm.push_back(facenorm);
	Szene::testcube_norm.push_back(facenorm);
	Szene::testcube_norm.push_back(facenorm);
	Szene::testcube_norm.push_back(facenorm);

	Szene::testcube_color.push_back(glm::vec3(1,1,0));
	Szene::testcube_color.push_back(glm::vec3(1,1,0));
	Szene::testcube_color.push_back(glm::vec3(1,1,0));
	Szene::testcube_color.push_back(glm::vec3(1,1,0));
	Szene::testcube_color.push_back(glm::vec3(1,1,0));
	Szene::testcube_color.push_back(glm::vec3(1,1,0));

	//bottom
	Szene::testcube_vert.push_back(glm::vec3(-1,-1,1));
	Szene::testcube_vert.push_back(glm::vec3(-1,-1,-1));
	Szene::testcube_vert.push_back(glm::vec3(1,-1,1));
	Szene::testcube_vert.push_back(glm::vec3(1,-1,1));
    Szene::testcube_vert.push_back(glm::vec3(1,-1,-1));
	Szene::testcube_vert.push_back(glm::vec3(-1,-1,-1));

	/*Szene::testcube_norm.push_back(glm::vec3(-1,-1,1));
	Szene::testcube_norm.push_back(glm::vec3(-1,-1,-1));
	Szene::testcube_norm.push_back(glm::vec3(1,-1,1));
	Szene::testcube_norm.push_back(glm::vec3(1,-1,1));
    Szene::testcube_norm.push_back(glm::vec3(1,-1,-1));
	Szene::testcube_norm.push_back(glm::vec3(-1,-1,-1));*/
	facenorm = glm::vec3(0,-1,0);
	Szene::testcube_norm.push_back(facenorm);
	Szene::testcube_norm.push_back(facenorm);
	Szene::testcube_norm.push_back(facenorm);
	Szene::testcube_norm.push_back(facenorm);
	Szene::testcube_norm.push_back(facenorm);
	Szene::testcube_norm.push_back(facenorm);

	Szene::testcube_color.push_back(glm::vec3(0,1,1));
	Szene::testcube_color.push_back(glm::vec3(0,1,1));
	Szene::testcube_color.push_back(glm::vec3(0,1,1));
	Szene::testcube_color.push_back(glm::vec3(0,1,1));
	Szene::testcube_color.push_back(glm::vec3(0,1,1));
	Szene::testcube_color.push_back(glm::vec3(0,1,1));

}

Renderable* Szene::findRenderableByName(std::string name) 
{
	for (int i = 0; i < Szene::szene.size(); i++)
	{
		if(name == Szene::szene[i].getName()) {
			Renderable* r = &Szene::szene[i];
			return r;
		}
	}
	return NULL;
}

GLuint* Szene::splitSkybox(const char* imagepath)
{
		printf("Reading image %s\n", imagepath);

		// Data read from the header of the BMP file
		unsigned char header[54];
		unsigned int dataPos;
		unsigned int imageSize;
		unsigned int width, height;
		// Actual RGB data
		unsigned char * data;

		// Open the file
		FILE * file = fopen(imagepath,"rb");
		if (!file)							    {printf("Image could not be opened\n"); return 0;}

		// Read the header, i.e. the 54 first bytes

		// If less than 54 byes are read, problem
		if ( fread(header, 1, 54, file)!=54 ){ 
			printf("Not a correct BMP file1\n");
			return false;
		}
		// A BMP files always begins with "BM"
		if ( header[0]!='B' || header[1]!='M' ){
			printf("Not a correct BMP file2\n");
			return 0;
		}
		// Make sure this is a 24bpp file
		if ( *(int*)&(header[0x1E])!=0  )         {printf("Not a correct BMP file3\n");    return 0;}
		if ( *(int*)&(header[0x1C])!=24 )         {printf("Not a correct BMP file4\n");    return 0;}

		// Read the information about the image
		dataPos    = *(int*)&(header[0x0A]);
		imageSize  = *(int*)&(header[0x22]);
		width      = *(int*)&(header[0x12]);
		height     = *(int*)&(header[0x16]);

		// Some BMP files are misformatted, guess missing information
		if (imageSize==0)    imageSize=width*height*3; // 3 : one byte for each Red, Green and Blue component
		if (dataPos==0)      dataPos=54; // The BMP header is done that way

		// Create a buffer
		data = new unsigned char [imageSize];

		// Read the actual data from the file into the buffer
		fread(data,1,imageSize,file);

		// Everything is in memory now, the file wan be closed
		fclose (file);

		const int side_w = width/4;
		const int side_h = height/3;
		if(side_w != side_h) {printf("Not a 3:4 aspekt Ration!\n");    return 0;}

		//bmp startet links unten
		int bounds[6][4] =
		{
			{2*side_w,side_h  ,3*side_w,2*side_h},  //CUBE_MAP_POSITIVE_X
			{0       ,side_h  ,side_w  ,2*side_h},
			{side_w  ,2*side_h,2*side_w,3*side_h},  //CUBE_MAP_POSITIVE_Y
			{side_w  ,0       ,2*side_w,side_h  },
			{3*side_w,side_h  ,4*side_w,2*side_h},	//CUBE_MAP_POSITIVE_Z
			{side_w  ,side_h  ,2*side_w,2*side_h}
		};
		


	
		int face_datacounter[6];

		//pixelsize 3byte
		const int ps = 3;
		const int s = side_w*side_h*ps;
		unsigned char** imgs = 0;
		imgs = new unsigned char*[6];
		for(int i = 0; i<6; i++)
		{
			imgs[i] = new unsigned char[s];
			face_datacounter[i] = 0;
		}
		int c=0;
		for(int i = 0; i<imageSize/3;i++)
		{
			int x = i % width;
			int y = i / width;
			int face = -1;
			for(int j = 0; j < 6; j++)
			{
				if(x>=bounds[j][0] && y>=bounds[j][1] && x<bounds[j][2] && y<bounds[j][3])
				{
					face = j; break;
				}
			}
			if(face == -1) 
				continue;
			if(face == 1 && c==0)
				c++;
			
			imgs[face][face_datacounter[face]*3+0] = data[i*3+0];
			imgs[face][face_datacounter[face]*3+1] = data[i*3+1];
			imgs[face][face_datacounter[face]*3+2] = data[i*3+2];
			face_datacounter[face]++;

		}



		// Create one OpenGL texture
		GLuint *textureID=new GLuint[6];
		glGenTextures(6, textureID);
	
		for(int i = 0; i<6; i++)
		{
			// "Bind" the newly created texture : all future texture functions will modify this texture
			glBindTexture(GL_TEXTURE_2D, textureID[i]);

			// Give the image to OpenGL
			glTexImage2D(GL_TEXTURE_2D, 0,GL_RGB, side_w, side_h, 0, GL_BGR, GL_UNSIGNED_BYTE, &imgs[i][0]);
			delete [] imgs[i];

			// Poor filtering, or ...
			//glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
			//glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST); 

			// ... nice trilinear filtering.
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR); 
			glGenerateMipmap(GL_TEXTURE_2D);
		}
		delete []imgs;
		// Return the ID of the texture we just created
		return textureID;

}